<?php

/************************************************************
 * InfiniteWP Admin panel									*
 * Copyright (c) 2015 Revmakx								*
 * www.revmakx.com											*
 *															*
 ************************************************************/

#class providing functions for getting favicon

class Favicon{

	public static $localPath 		= 'uploads/favicon/';
	public static $defaultTimeout 	= 5; //sec
	public static function getFaviconsCronJob($cronStartTime){
		$sitesData = DB::getArray("?:sites", "siteID, favicon, URL, lastFaviconUpdate", "1 ORDER BY siteID ASC");
		foreach ($sitesData as $siteData) {
			if(($cronStartTime + CRON_TIMEOUT) > time()){ 
				self::validateFavicon($siteData);
			}
		}		
	}
	public static function refreshFaviconSite($siteID){
		$siteData = DB::getArray("?:sites", "siteID, favicon, URL, lastFaviconUpdate", "siteID = '".$siteID."'");
		self::getFavicon($siteData[0]);
	}
	public static function getFaviconsPanelIdle(){
		$limit = 10;	
		$limitChecker=0;
		$sitesData = DB::getArray("?:sites", "siteID, favicon, URL, lastFaviconUpdate", "1 ORDER BY siteID ASC");
		foreach ($sitesData as $siteData) {
			if ($limitChecker < $limit) {
				if(self::validateFavicon($siteData) != false){
					$limitChecker++;
				}
			}else {
				break;
			}
		}
}

	public static function validateFavicon($siteData){
		$checkUpdateFavicon	= 7*24*60*60; // 7 days
		$checkAddNewFavicon = 2*24*60*60; // 2 days    
		$lastFaviconUpdate 	= $siteData['lastFaviconUpdate']; 
		$faviconPath 		= $siteData['favicon'];
		$timeDifference 	= time() - $lastFaviconUpdate ;
		
		if (($faviconPath == 'default' && $timeDifference >= $checkAddNewFavicon )|| $timeDifference >= $checkUpdateFavicon || ($lastFaviconUpdate == 0 || $faviconPath == NULL)) {
			self::getFavicon($siteData);
		} else {
			return false;
		}
	}

	public static function getFavicon($siteData){
		if(self::getFaviconFromPageContent($siteData) !== false){
			return '';
		}
		if(self::getFaviconFromRootPath($siteData) !== false ){
			return '';
		}
		self::defaultFavicon($siteData['siteID']);
	}

	public static function getFaviconFromRootPath($siteData) {
		$URL 	= $siteData['URL']."favicon.ico";
		$siteID = $siteData['siteID'];
		$lastFaviconUpdate = $siteData['lastFaviconUpdate']; 
		list( , , , $curlInfo,) = doCall($URL, $data = '', self::$defaultTimeout);
	   	$curlInfo = $curlInfo['info'];
	    if ($curlInfo['size_download'] > 1 && $curlInfo['size_download'] > $curlInfo['download_content_length']) {
	        $downloadSize = $curlInfo['size_download'];
	    } elseif ($curlInfo['download_content_length'] > 1) {
	        $downloadSize = $curlInfo['download_content_length'];
	    } 
		if (self::isImageFound($curlInfo['content_type'])) {
		    if ($curlInfo['http_code'] == 200 && $downloadSize > 1) {
		       	return self::storeFaviconAndDBUpdate($URL, $siteID, $lastFaviconUpdate);	
		     } else {
				return false;
		     }
	 	} else {
			return false;
	 	}
	}

	public static function isImageFound($contentType){
		if (strstr($contentType, "image") !== false || strstr($contentType, "text/plain") !== false) {
	        return true;
	    }else {
	    	return false;
	    }
	}

	public static function getFaviconFromPageContent($siteData) {
		$siteID = $siteData['siteID'];
		$lastFaviconUpdate = $siteData['lastFaviconUpdate'];
		$faviconNotFound = 0;
		$URL 	= $siteData['URL'];

		list($HTMLContent, , , $curlInfo,) = doCall($URL, $data = '', self::$defaultTimeout);
	   	$curlInfo = $curlInfo['info'];
		if (self::isFaviconFound($curlInfo['http_code'],$HTMLContent)) {
        	$faviconURL = self::parseHTMLContent($HTMLContent, $URL);
        	if($faviconURL){
        		return self::storeFaviconAndDBUpdate($faviconURL, $siteID, $lastFaviconUpdate); 
        	} else {
        		$faviconNotFound = 1 ;
        	}       
		} else {
			$faviconNotFound = 1 ;
		}
		if ($faviconNotFound == 1) {
			return false;
		}
	}
	public static function isFaviconFound($httpStatus,$HTMLContent){
		if ($httpStatus == 200 && (strpos($HTMLContent, "icon") !== false || strpos($HTMLContent, "shortcut icon") !== false)) {
			return true;
		} else{
			return false;
		} 
	}

	public static function parseHTMLContent($HTMLContent, $URL) {
		include_once(APP_ROOT."/lib/htmlParser/simple_html_dom.php");
		$DOM = str_get_html($HTMLContent);
		$relTypesofFavicon = array('link[rel=shortcut icon]', 'link[rel=icon]');
		$faviconFound = 0;
		foreach ($relTypesofFavicon as $relTypeofFavicon) {
			if (!$faviconFound) {
				foreach($DOM->find($relTypeofFavicon) as $element) {
	   				$faviconURL = $element->href;
	   				if ($faviconURL) {
	   					$faviconFound = 1;
	   					break;
	   				}
	  			}
  			} else {
  				break;
  			}
		}
		if (isset($faviconURL) && !empty($faviconURL)) {
		    return  self::findFaviconURLType($faviconURL, $URL);
  		}else {
	        return false;
	    }	
	}

	public static function storeFaviconAndDBUpdate($URL,$siteID, $lastFaviconUpdate){
		$currentTime = time();
		$fileName  = $siteID."_".$currentTime;
		self::createFolder();
	    $localPath = self::$localPath.''.$fileName . '.ico';
	    $result = self::storeFavicontoLocalstorage($URL, $localPath, $siteID, $lastFaviconUpdate); //to store icon into local
	  	if ($result) {
	 		return self::updateFavicon($siteID, $localPath, $lastFaviconUpdate ,$localPath, $currentTime, true); 	
	  	} else {
	 		return self::updateFavicon($siteID, $localPath, $lastFaviconUpdate ,$localPath, $currentTime, false); 	
	  	}
	}
	public static function createFolder(){
		$localPath = self::$localPath;
		if(!file_exists($localPath)){
			 if(!mkdir(self::$localPath, 0755, true)){
				addNotification($type='E', $title='Cannot create folder', $message='Please change the default folder permission for UPLOADS folder to 755', $state='U', $callbackOnClose='', $callbackReference='');
			 }
		}
	}
	public static function updateFavicon($siteID, $localPath, $lastFaviconUpdate ,$localPath, $currentTime,$status){
	  	if ($status) {
	  		DB::update("?:sites", array( //update local path
	        'favicon' => $localPath,
	        'lastFaviconUpdate' => $currentTime
		    ), "siteID=" . $siteID); 
		    $deleteFavicon = $siteID."_".$lastFaviconUpdate;
		    $deleteFavicon = self::$localPath.''.$deleteFavicon.'.ico';
		    if (file_exists($deleteFavicon)) {
		       		unlink($deleteFavicon);
			}	
	  	} else {
	  		DB::update("?:sites", array( //update local path
	        'lastFaviconUpdate' => time()
		    ), "siteID=" . $siteID); 
		    
	  	} 	  
	  	return true;
	}
	public static function findFaviconURLType($faviconURL, $URL){
			if (!empty($faviconURL)) {
			$HREFInfo = parse_url($faviconURL);
	        if (!empty($HREFInfo['scheme']) && !empty($HREFInfo['host']) && !empty($HREFInfo['path'])) {
	        	return self::verifyFaviconURL($faviconURL);
	        } else if (empty($HREFInfo['scheme']) && empty($HREFInfo['host'])) {
	        	return self::relativeURL($HREFInfo, $URL);
	        } else if (empty($HREFInfo['scheme']) && (!empty($HREFInfo['host']) && !empty($HREFInfo['path']))) {
	    		return self::absoluteURLWithoutScheme($HREFInfo);
	        } else {
	            return false;
	    	} 
	    }
	}

	public static function relativeURL($HREFInfo, $URL){
        $faviconURL = $URL.''.ltrim($HREFInfo['path'], '/');
        return self::verifyFaviconURL($faviconURL);
	}

	public static function absoluteURLWithoutScheme($HREFInfo){
		$faviconURL = $HREFInfo['host'].''.$HREFInfo['path'];
		return self::verifyFaviconURL($faviconURL);
	}

	public static function verifyFaviconURL($faviconURL){
		list(, , , $curlInfo,)  	= doCall($faviconURL, $data = '', self::$defaultTimeout);
	    $curlInfo = $curlInfo['info'];
	    if ($curlInfo['http_code'] == 200 && strstr($curlInfo['content_type'], "image") != null) {
	      return $faviconURL;
        } else {
            return false;
        }
	}
	public static function storeFavicontoLocalstorage($URL, $saveTo)
	{	
		
		list($faviconData, , , $curlInfo, )  = doCall($URL, $data = '', self::$defaultTimeout);
		$curlInfo = $curlInfo['info'];
	    if ($curlInfo['size_download'] > 1 && $curlInfo['size_download'] > $curlInfo['download_content_length']) {
	        $downloadSize = $curlInfo['size_download'];
	    } elseif ($curlInfo['download_content_length'] > 1) {
	        $downloadSize = $curlInfo['download_content_length'];
	    } 

		if (self::isImageFound($curlInfo['content_type'])) {
			if ($curlInfo['http_code'] == 200 && $downloadSize > 1) {
		        $fp = fopen($saveTo, 'x');
			    fwrite($fp, $faviconData);
			    fclose($fp);
			    return true;
		     } else {
		     	return false;
		     }
		} else {
			return false;
		}

	       
	}
	public static function defaultFavicon($siteID){
		$time = time();
	    DB::update("?:sites", array(//update local path
	            'favicon' => 'default',
	            'lastFaviconUpdate' => $time
	    ), "siteID=" . $siteID);
	}
	public static function removeFavicon($siteID){
		$removeSiteData = DB::getArray("?:sites", "favicon, lastFaviconUpdate","siteID ='".$siteID."'");
   		$deleteFavicon = $removeSiteData[0]['favicon'];
		 if (file_exists($deleteFavicon)) {
	       		unlink($deleteFavicon);
		}	
	}

} 